/*
 *  BeatDetector.cpp
 *  BeatDetection
 *
 *  Created by Serban Porumbescu on 11/8/10.
 *  Copyright 2010 Hidden Elephant Software. All rights reserved.
 *
 */

#include "BeatDetector.h"
#include <math.h>
#include <iostream>

BeatDetector::BeatDetector()
{
   energy = 0.0f;
   energyLevel = 0.0f;
}

void BeatDetector::AudioProcess(float *input, unsigned int length, 
                                unsigned int nChannels)
{
   energy = 0.0f;
   for (unsigned int i = 0; i < length; i += 2) 
   {
      float channel_average = (input[i] + input[i+1]) * 0.5f * 0.9f;
      
      if(channel_average > energy)
         energy = channel_average;
   }
   
   if(energy > 0.35f)
   {
      energyLevel = energy;
   }
}

void BeatDetector::update()
{
   energyLevel *= 0.9f;
}